package jp.a2kichi.android.itemsearch;

import java.util.List;
import android.os.Handler;
import android.util.Log;

public class InfoController extends Thread {
    private Handler handler;
    private final Runnable listener;
    private String word;
    private TargetInfo targetInfo;
    
	private RakutenInfo rakutenInfo = null;
	private KakakuComInfo kakakucomInfo = null;
	private YahooInfo yahooInfo = null;
	
	public InfoController(Handler handler, Runnable listener, TargetInfo targetInfo, String word) {
		this.handler   = handler;
		this.listener  = listener;
		this.word = word;
		this.targetInfo = targetInfo;
	}
	
    @Override
    public void run() {
        Log.v("EXAM", "run");
    	if (targetInfo.getRakutenChecked()) {
            rakutenInfo = new RakutenInfo();
        	rakutenInfo.setRakutenInfo(word);
    	}
    	if (targetInfo.getKakakucomChecked()) {
            kakakucomInfo = new KakakuComInfo();
        	kakakucomInfo.setKakakuComInfo(word);
    	}
    	if (targetInfo.getYahooChecked()) {
            yahooInfo = new YahooInfo();
        	yahooInfo.setYahooInfo(word);
    	}
    	handler.post(listener);
    }
    
	public List<RakutenInfo> getRakutenItemList() {
		if (rakutenInfo != null) {
			return rakutenInfo.getRakutenInfoList();
		}
		return null;
	}
	public List<KakakuComInfo> getKakakuComItemList() {
		if (kakakucomInfo != null) {
			return kakakucomInfo.getKakakuComInfoList();
		}
		return null;
	}
	public List<YahooInfo> getYahooItemList() {
		if (yahooInfo != null) {
			return yahooInfo.getYahooInfoList();
		}
		return null;
	}
}
