package jp.a2kichi.android.itemsearch;

import java.io.*;
import java.util.ArrayList;
import org.xmlpull.v1.*;

public class XmlParserFromUrl {
	private XmlPullParser xpp;
    private XmlPullParserFactory factory;
	private int eventType = 999;
	private String tag = null;
	private String tag_before = null;
	
	public XmlParserFromUrl() {
		try {
			factory = XmlPullParserFactory.newInstance();
		} catch (XmlPullParserException e) {
			e.printStackTrace();
		}
        factory.setNamespaceAware(true);
	}
	
	public ArrayList<RakutenInfo> getRakutenItemListFromXML(InputStream is) {
		ArrayList<RakutenInfo> list = new ArrayList<RakutenInfo>();
		RakutenInfo tempRakuten = new RakutenInfo();
        
		if (is == null)
			return null;

        try {
        	initXmlPullParser(is);
			while (eventType != XmlPullParser.END_DOCUMENT) {
				if (eventType == XmlPullParser.START_TAG) {
					tag = xpp.getName();
    
					if(tag.compareTo(RakutenInfo.ATTR_NAME) == 0) {
						tempRakuten.item_name = getText(); 
					}
					if(tag.compareTo(RakutenInfo.ATTR_PRICE) == 0) {
						tempRakuten.item_price = getText(); 
					}
					if(tag.compareTo(RakutenInfo.ATTR_URL) == 0) {
						tempRakuten.item_url = getText(); 
						list.add(tempRakuten);
						tempRakuten = new RakutenInfo();
					}
				}
				eventType = xpp.next();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

		return list;
	}

	public ArrayList<KakakuComInfo> getKakakuComItemListFromXML(InputStream is) {
		ArrayList<KakakuComInfo> list = new ArrayList<KakakuComInfo>();
		KakakuComInfo tempKakakuCom = new KakakuComInfo();
        
		if (is == null)
			return null;

        try {
        	initXmlPullParser(is);
			while (eventType != XmlPullParser.END_DOCUMENT) {
				if (eventType == XmlPullParser.START_TAG) {
					tag = xpp.getName();
					if(tag.compareTo(KakakuComInfo.ATTR_NAME) == 0) {
						tempKakakuCom.item_name = getText(); 
					}
					if(tag.compareTo(KakakuComInfo.ATTR_URL) == 0) {
						tempKakakuCom.item_url = getText(); 
					}
					if(tag.compareTo(KakakuComInfo.ATTR_PRICE) == 0) {
						tempKakakuCom.item_price = getText();
						list.add(tempKakakuCom);
						tempKakakuCom = new KakakuComInfo();
					}
			    }
				eventType = xpp.next();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

		return list;
	}

	public ArrayList<YahooInfo> getYahooItemListFromXML(InputStream is) {
		ArrayList<YahooInfo> list = new ArrayList<YahooInfo>();
		YahooInfo tempYahoo = new YahooInfo();
		if (is == null)
			return null;

        try {
        	initXmlPullParser(is);
			while (eventType != XmlPullParser.END_DOCUMENT) {
				if (eventType == XmlPullParser.START_TAG) {
					tag = xpp.getName();

					if(tag.compareTo(YahooInfo.ATTR_NAME) == 0 && tag_before != null) {
						if(tag_before.compareTo(YahooInfo.ATTR_HIT) == 0) {
							tempYahoo.item_name = getText();
						}
					}
					if(tag.compareTo(YahooInfo.ATTR_URL) == 0 && tag_before != null) {
						if(tag_before.compareTo(YahooInfo.ATTR_HEADLINE) == 0) {
							tempYahoo.item_url = getText();
						}
					}
					if(tag.compareTo(YahooInfo.ATTR_PRICE) == 0 && tag_before != null) {
						if(tag_before.compareTo(YahooInfo.ATTR_RATE) == 0) {
							tempYahoo.item_price = getText(); 
							list.add(tempYahoo);
							tempYahoo = new YahooInfo();
						}
					}
					tag_before = tag;
				}
				eventType = xpp.next();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return list;
	}
	
	private String getText() throws XmlPullParserException, IOException {
        eventType = xpp.next();
        if (eventType == XmlPullParser.TEXT) {
    		return xpp.getText();
        }
       	return "UnKnown";
	}
	
	private void initXmlPullParser(InputStream is) {
        try {
			xpp = factory.newPullParser();
	        xpp.setInput(is, "UTF-8");
	        
		} catch (XmlPullParserException e) {
			e.printStackTrace();
		}

		eventType = 0;
	}
}
